<!DOCTYPE html>
<html>

<head>
  <title>HEX/DEC/OCT calculation</title>
</head>

<body>

  <div class="main-container">
    <h2 class="title">Question Placeholder</h2>
    <h3 class="time">20</h3>
    <h3 class="timeLeft">Time left </h3>
    <h3 class="currentScore">0</h3>
    <h3 class="score">Score</h3>
    <div class="input-wrapper">
      <input type="text" class="input" data-dom-state="input-1" />
    </div>
    <div class="button-wrapper">
      <button class="button" onclick="changeLabelTo('1')">1</button>
      <button class="button" onclick="changeLabelTo('2')">2</button>
      <button class="button" onclick="changeLabelTo('3')">3</button>
      <button class="button" onclick="changeLabelTo('4')">4</button>
      <button class="button" onclick="changeLabelTo('5')">5</button>
      <button class="button" onclick="changeLabelTo('6')">6</button>
      <button class="button" onclick="changeLabelTo('7')">7</button>
      <button class="button" onclick="changeLabelTo('8')">8</button>
      <button class="button" onclick="changeLabelTo('9')">9</button>
      <button class="button" onclick="changeLabelTo('.')">.</button>
      <button class="button" onclick="changeLabelTo('-')">-</button>
      <button class="button" onclick="changeLabelTo('0')">0</button>
    </div>
    <button class="button-2" onclick=checkInput()>Enter</button>
  </div>
  <div class="builder-canvas"></div>

  <style>
    .main-container {
      align-items: center;
      background-color: rgb(49, 49, 49, 1);
      color: #fff;
      display: flex;
      flex-direction: column;
      height: 100vh;
      justify-content: center;
    }

    .title {
      font-size: 24px;
      margin-bottom: 20px;
    }

    .time {
      position: absolute;
      top: 10%;
      left: 90%;
      transform: translateX(-50%);
      font-size: 24px;
      /* Schriftgröße nach*/
    }

    .timeLeft {
      position: absolute;
      top: 10%;
      left: 84%;
      transform: translateX(-50%);
      font-size: 24px;
      /* Schriftgröße nach*/
    }

    .currentScore {
      position: absolute;
      top: 20%;
      left: 90%;
      transform: translateX(-50%);
      font-size: 24px;
      /* Schriftgröße nach*/
    }

    .score {
      position: absolute;
      top: 20%;
      left: 85%;
      transform: translateX(-50%);
      font-size: 24px;
      /* Schriftgröße nach*/
    }

    .input-wrapper {
      align-items: center;
      display: flex;
      justify-content: center;
      margin-bottom: 20px;
    }

    .input {
      background-color: #333;
      border-radius: 5px;
      border-top-left-radius: 5px;
      color: #fff;
      font-size: 18px;
      height: 40px;
      width: 250px;
      padding: 10px;
    }

    .button-wrapper {
      column-gap: 10px;
      display: grid;
      gap: 10px;
      grid-template-columns: repeat(3, 1fr);
      margin-bottom: 20px;
      row-gap: 10px;
    }

    .button {
      all: unset;
      border-bottom: none;
      border-color: #fff;
      border-left: none;
      border-radius: 5px;
      border-right: none;
      border-top: none;
      border-top-left-radius: 5px;
      color: #000;
      font-size: 26px;
      text-align: center;
      height: 60px;
      width: 80px;
      padding: 10px;
      border-radius: 10px;
      background-color: rgba(1000, 255, 255, 255);
    }

    .button-2 {
      all: unset;
      background-color: #0087f0;
      border-bottom: none;
      border-color: #fff;
      border-left: none;
      border-radius: 5px;
      border-right: none;
      border-top: none;
      border-top-left-radius: 5px;
      color: #000;
      font-size: 30px;
      text-align: center;
      height: 80px;
      width: 258px;
      padding: 10px;
      border-radius: 10px;
      background-color: rgba(0, 184, 252, 1);
    }

    .builder-canvas {
      display: flex;
      flex-direction: column;
      position: relative;
      min-height: 500px;
    }
  </style>
  <script src="scripts/statistics.js"></script>
  <script src="scripts/scoring.js"></script>
  <script>

    var num
    var unit

    const statisticsHelper = new StatisticsHelper();

    num = Math.floor(Math.random() * 101) //generate random number between 0 and 100 (no negatives needed for this exercise)
    var hexnum = num.toString(16) //generates the hexadezimal equivalent to decimal num
    var binnum = num.toString(2) //generates the binary equivalent to decimal num
    var octnum = num.toString(8) //generates the octal equivalent to decimal num

    unit = generateRandomNum(0, (Object.keys(createDict()).length))  // determines randomly which conversion to use
    function generateRandomNum(min, max) {
      // generate a random number for conversions
      // from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/random?retiredLocale=de (11/11/23)
      min = Math.ceil(min);
      max = Math.floor(max);
      return Math.floor(Math.random() * (max - min) + min); // The maximum is exclusive and the minimum is inclusive
    }

    function getSols(conversiontype) {
      // converts current number based on the conversiontype
      switch (conversiontype) {
        case 0: //HEX TO DEC
          return num
        case 1: //BIN TO DEC
          return num
        case 2: //HEX TO BIN
          return binnum
        case 3: //DEC TO BIN
          return binnum
        case 4: //OCT TO DEC
          return num
        case 5: //DEC TO OCT
          return octnum
        default:
          return [0]
      }


    }

    function createDict() {
      // create dictionary with questions
      var questionnaire = {
        "quest1": `Transform ${hexnum} from HEX to DEC`,
        "quest2": `Transform ${binnum} from BIN to DEC`,
        "quest3": `Transform ${hexnum} from HEX to BIN`,
        "quest4": `Transform ${num} from DEC to BIN`,
        "quest5": `Transform ${octnum} from OCT to DEC`,
        "quest6": `Transform ${num} from DEC to OCT`,
      }
      return questionnaire
    }

    function generateRandomQuest(questionnaire, unit) {
      var key = Object.keys(questionnaire)  // get list of all keys
      return questionnaire[key[unit]]  // return random question
    }

    function changeQuestionLabelTo(questionnaire, unit) {
      // from https://stackoverflow.com/questions/21813122/changing-content-of-class-using-javascript (12/11/23)
      quest = generateRandomQuest(questionnaire, unit)
      x = document.getElementsByClassName('title')
      for (var i = 0; i < x.length; i++) {
        x[i].innerText = quest;
      }
    }

    function changeLabelTo(number) {
      // select input class and append number to the text label
      document.querySelector('.input').value += number;
    }

    function nextQuest() {
      num = Math.floor(Math.random() * 101)
      hexnum = num.toString(16)
      binnum = num.toString(2)
      octnum = num.toString(8)
      unit = generateRandomNum(0, (Object.keys(createDict()).length)) //picks the next unit from set of questions.
      changeQuestionLabelTo(createDict(), unit)
    }

    function clearInput() {
      // to clear input after entering
      document.querySelector('.input').value = '';
    }


    function checkInput() {
      var currentunit = unit
      var answerToQuest = getSols(currentunit)
      var userInput = document.querySelector('.input').value
      //setting answerToQuest always to string
      answerToQuest = answerToQuest.toString();
      if (userInput === answerToQuest) {
        scoreAnswerCorrect("", userInput)
      }
      else {
        scoreAnswerIncorrect()
      }
    }

    statisticsHelper.startRun("cs", "Example Name");

    changeQuestionLabelTo(createDict(), unit)

  </script>

</body>

</html>